(define (improve guess x)
  (/ (+ (/ x (square guess))
        (* 2 guess))
     3))

(define (average x y)
  (/ (+ x y) 2))

(define (square x)
  (* x x))

(define (cube x)
  (* x x x))

(define (my-good-enough? guess prev-guess)
  (< (abs (- guess prev-guess))
     (/ guess 100000)))

(define (my-cube-root-iter guess prev-guess x)
  (if (my-good-enough? guess prev-guess)
      guess
      (my-cube-root-iter (improve guess x)
                         guess
                         x)))

(define (my-cube-root x)
  (my-cube-root-iter 1.0 (improve 1.0 x) x))
